﻿Imports System
Imports Telerik.Windows.Controls
Imports Telerik.Windows.Controls.Navigation
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Data

Partial Public Class MainPage
  Inherits UserControl

  Public Shared ds As New DataItemCollection

  Public Sub New()
    InitializeComponent()

    ds.Add(New DataItem With {.Id = 0, .ParentId = -1, .Text = "RootItem", .ItemType = itemTypeEnum.Group})
    ds.Add(New DataItem With {.Id = 10, .ParentId = 0, .Text = "Group", .ItemType = itemTypeEnum.Group})
    ds.Add(New DataItem With {.Id = 11, .ParentId = 10, .Text = "SubGroup", .ItemType = itemTypeEnum.Group})
    ds.Add(New DataItem With {.Id = 12, .ParentId = 11, .Text = "Station", .ItemType = itemTypeEnum.Station})

    Me.DataContext = ds
    RadTreeView.ExpandAll()
    radTreeView.IsLineEnabled = True
    explorerBreadcrumb.PathSeparator = " » "
    radTreeView.PathSeparator = " » "
  End Sub

  Sub radTreeView_SelectionChanged(sender As System.Object, e As Telerik.Windows.Controls.SelectionChangedEventArgs)
    If e.AddedItems.Count > 0 AndAlso Me.radTreeView.ContainerFromItemRecursive(e.AddedItems(0)) IsNot Nothing Then
      Me.explorerBreadcrumb.Path = Me.radTreeView.ContainerFromItemRecursive(e.AddedItems(0)).FullPath
    End If
  End Sub

  Private Sub explorerBreadcrumb_CurrentItemChanged(sender As System.Object, e As Telerik.Windows.RadRoutedEventArgs)
    Me.radTreeView.BringPathIntoView(Me.explorerBreadcrumb.Path)
    Me.radTreeView.SelectedItem = Me.explorerBreadcrumb.CurrentItem
  End Sub

  Private Sub btAdd_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
    ds.Add(New DataItem With {.Id = 13, .ParentId = 0, .Text = "TestGroup", .ItemType = itemTypeEnum.Group})
  End Sub

  Private Sub btChange_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btChange.Click
    If radTreeView.SelectedItem IsNot Nothing Then
      Dim item = TryCast(radTreeView.SelectedItem, DataItem)
      If item.state = stateEnum.Ok Then item.state = stateEnum.Error Else item.state = stateEnum.Ok
    End If
  End Sub
End Class
